]> git.treefish.org Git - backmeupscotty.git/blob - backmeupscotty
formatting
[backmeupscotty.git] / backmeupscotty
1 #!/bin/bash
2
3 REMOTE_HOST=localhost
4 REMOTE_DIR=/tmp/backmeupscotty/test
5 ARCHIVE_KEEPNBACKUPS=30
6 ARCHIVE_KEEPNDAYS=30
7 BACKUP_RUNEVERYNTHDAY=1
8 BWLIMIT=500KiB
9
10 _ERROR_ENCOUNTERED=0
11
12 function timestamp {
13     date +'[%y-%m-%d|%H:%M:%S]'
14 }
15
16 function scottyline {
17     echo $(timestamp) $@
18 }
19
20 function scottyinfo {
21     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
22         scottyline $@
23     else
24         scottyline $@ >&2
25     fi
26 }
27
28 function scottyerror {
29     scottyline $@ >&2
30     if [ $_ERROR_ENCOUNTERED -eq 0 ]; then
31         _ERROR_ENCOUNTERED=1
32         scottyline "Going into verbose mode after error encounter." >&2
33     fi
34 }
35
36 function ssh255 {
37     ssh $@
38     sshret=$?
39
40     if [ $sshret -eq 255 ]; then
41         scottyerror "SSH connection failed!"
42         exit 1
43     else
44         return $sshret
45     fi
46 }
47
48 function grepbackups {
49     ssh255 $REMOTE_HOST "ls $REMOTE_DIR" | grep -E '[0-9]+-[0-9]+'
50 }
51
52 function isIncomplete {
53     if ( ssh255 $REMOTE_HOST '[ -d '$REMOTE_DIR/incomplete' ]' ); then
54         return 0
55     else
56         return 1
57     fi
58 }
59
60 function isNthDay {
61     if [ $(( ( $(date +%s) / (60*60*24) ) % $BACKUP_RUNEVERYNTHDAY )) -eq 0 ];
62     then
63         return 0
64     else
65         return 1
66     fi
67 }
68
69 function latestTooOld {
70     for oldbackup in $(grepbackups); do
71         tstamp=$(echo $oldbackup | cut -d'-' -f1)
72
73         if [ $(( $(date +%s) - $tstamp )) -lt $(( ($BACKUP_RUNEVERYNTHDAY*24+12)*60*60 )) ]
74         then
75             return 1
76         fi
77     done
78
79     return 0
80 }
81
82 function scottysync {
83     timestamp=$(date +%s)
84
85     scottyinfo "Syncing $SYNC_SRC to $REMOTE_HOST:$REMOTE_DIR @$timestamp."
86
87     if [ ! -d "$SYNC_SRC" ]; then
88         scottyerror "Source dir $SYNC_SRC does not exist. Not syncing!"
89         return 1
90     fi
91
92     if [ $(ls -A "$SYNC_SRC" | wc -l) -eq 0 ]; then
93         scottyerror "Source dir $SYNC_SRC is empty. Not syncing!"
94         return 1
95     fi
96
97     dir_current=$REMOTE_DIR/current
98     dir_incomplete=$REMOTE_DIR/incomplete
99     dir_timestamped=$REMOTE_DIR/$timestamp-$(date -d @$timestamp +%Y%m%d%H%M%S)
100
101     if [ -z $SYNC_EXC ]; then
102         rsync_exclude=""
103     else
104         rsync_exclude=$(eval echo --exclude={$SYNC_EXC} | tr -d {})
105     fi
106
107     if (ssh255 $REMOTE_HOST '[ ! -d '$REMOTE_DIR' ]'); then
108         scottyinfo "Creating destination directory $REMOTE_HOST:$REMOTE_DIR."
109         ssh255 $REMOTE_HOST "mkdir $REMOTE_DIR"
110     fi
111
112     if isIncomplete; then
113         scottyerror "Continuing old incomplete backup."
114     fi
115
116     scottyinfo "Starting rsync."
117     rsync -e ssh --bwlimit=$BWLIMIT \
118           -v -aHAX --numeric-ids --delete --delete-excluded \
119           --link-dest=$dir_current \
120           $rsync_exclude \
121           $SYNC_SRC/ $REMOTE_HOST:$dir_incomplete/
122
123     if [ $? -eq 0 ]; then
124         scottyinfo "Timestamping completed backup and linking to current backup."
125         ssh255 $REMOTE_HOST \
126                "mv $dir_incomplete $dir_timestamped && rm -f $dir_current && \
127                ln -s $(basename $dir_timestamped) $dir_current"
128     else
129         scottyerror "Rsync failed."
130     fi
131
132     while [ $(grepbackups | wc -l) -gt $ARCHIVE_KEEPNBACKUPS ]; do
133         oldestbackup=$(grepbackups | head -1)
134         oldestbackuptstamp=$(echo $oldestbackup | cut -d'-' -f1)
135
136         if [ $oldestbackuptstamp -lt $(( $(date +%s) - $ARCHIVE_KEEPNDAYS*60*60*24 )) ]; then
137             scottyinfo "Removing old backup $oldestbackup."
138             ssh255 $REMOTE_HOST rm -r "$REMOTE_DIR/$oldestbackup"
139         else
140             break
141         fi
142     done
143 }
144
145 function deleteLock {
146     if ! rmdir /var/lock/$(basename $0); then
147         scottyerror "Could not delete lockfile /tmp/$(basename $0).lock!"
148     fi
149 }
150
151 function cleanup_abort {
152     scottyerror "Caught exit signal! Cleaning up."
153
154     cleanup ABORT
155
156     if [ $(jobs -p) ]; then
157         scottyerror "TERMinating remaining child processes."
158         kill $(jobs -p)
159     fi
160
161     deleteLock
162
163     exit
164 }
165
166 function cleanup {
167     scottyinfo "No cleanup function was defined."
168 }
169
170 function prepare {
171     scottyinfo "No prepare function was defined."
172 }
173
174 function cleanup_normal {
175     cleanup
176     deleteLock
177 }
178
179 function printhelp {
180     cat <<EOF
181 Usage: $(basename $0) [OPTION]...
182
183 Recognized options:
184   -q   Only output errors
185   -n   Run only on nth day
186   -h   Print out this help
187 EOF
188 }
189
190 function backmeupscotty {
191     while getopts "qn:h" opt; do
192         case $opt in
193             q)
194                 exec > /dev/null
195                 ;;
196             n)
197                 BACKUP_RUNEVERYNTHDAY=$OPTARG
198                 ;;
199             h)
200                 printhelp
201                 exit 0
202                 ;;
203         esac
204     done
205
206     ssh255 $REMOTE_HOST exit
207
208     if latestTooOld; then
209         scottyerror "The latest backup is too old."
210     elif isNthDay; then
211         scottyinfo "This is the nth day."
212     else
213         scottyinfo "No backup has to be done. Exiting."
214         exit 0
215     fi
216
217     scottyinfo "Performing backup."
218
219     trap cleanup_abort EXIT
220
221     prepare
222     scottysync
223
224     trap cleanup_normal EXIT
225
226     exit 0
227 }
228
229 if ! mkdir /var/lock/$(basename $0); then
230     scottyerror "Another instance of $(basename $0) is still running!"
231     exit 1
232 else
233     trap deleteLock EXIT
234 fi